alias crayola {
  %br.file = farger.inc
  %br.file = colopal.txt
  %br.sz = 22
  _window
  var %f = %br.file
  var %i = 1, %r, %n = $lines(%f), %j = 0
  e %n Lines in %f
  while (%i <= %n) {
    %r = $read(%f,n,%i)
    if (*decl*color*rgb* iswm %r) {
      thumbnail $remove($gettok(%r,6-,32),$chr(32)) %i
    }
    else {
      if (*declare*;* iswm %r) {
        thumbnail $remove($gettok(%r,5-,32),$chr(32)) %i
      }
    }
    else inc %j
    inc %i
  }
  e $calc(%n - %j) significant colors
  drawsave @board hsvhsl.jpg
}
alias _window {
  %br.w = $window(-1).w
  dec %br.w 70
  %br.h = $window(-1).h
  if ($window(@board) == $null) window -pd +d @board 0 0 %br.w %br.h
  else window -a @board
  drawrect -f @board 10 1 0 0 %br.w %br.h
}
alias thumbnail {
  var %sz = %br.sz, %fitall = 0
  var %d1 = $replace($replace($1,green,$chr(44)),blue,$chr(44))

  var %c = $remove(%d1,;,red,>,<)
  if ($numtok(%c,44) == 1) %c = %c , %c , %c
  ; e %c
  var %r = $round($calc($gettok(%c,1,44) * 255),0)
  var %g = $round($calc($gettok(%c,2,44) * 255),0)
  var %b = $round($calc($gettok(%c,3,44) * 255),0)
  %c = $rgb(%r,%g,%b)
  var %m = $calc($int($calc(%br.w / %sz)) - %fitall)
  var %x = $calc((($2 - 1) % %m) * %sz)
  var %y = $calc($int($calc(($2 - 1) / %m)) * %sz)
  if (%y < %br.h) drawrect -fr @board %c 1 %x %y %sz %sz
}
alias -l e echo -s : $1-
alias getname {
  var %sz = %br.sz, %fitall = 0
  var %m = $calc($int($calc(%br.w / %sz)) - %fitall)
  ; e %m MMMM
  if ($mouse.x > $calc(%sz * %m)) { e off edge | halt }
  var %x = $calc($int($calc($mouse.x / %sz)) + 1)
  var %y = $int($calc($mouse.y / %sz))
  var %f = %br.file
  var %i = $calc(%m * %y + %x)
  var %r = $read(%f,n,%i)
  if (%i > $lines(%f)) { e no more colors | halt }
  e line: %i
  return %r
}
alias clipname {
  var %r = $getname
  if (*>;* iswm %r) {
    clipboard %r
    ; $gettok(%r,2,32)
    ; actvmirc
    popups $gettok(%r,2,32)
    e $gettok(%r,2,32) $remove($gettok(%r,5-,32),$chr(32))
  }
  else e not a color
}
alias actvmirc {
  window -p +d @tmp 0 0 90 90
  window -a @tmp
  close -@ @tmp
}
alias popups {
  var %w = $calc(8 * $len($1-))
  if ($window(@pop)) { .timer.pop off | window -c @pop }
  .timer.pop 1 10 window -c @pop
  window -pd +d @pop $mouse.x $mouse.y %w 20
  drawrect -f @pop 1 2 0 0 %w 20
  drawtext -r @pop 16777215 Arial 12 4 2 $1
}


alias mouseover {
  if (!$fopen(crayola)) .fopen crayola %br.file
  var %r = $fgetname(1)
  var %w = $calc(8 * $len(%r))
  if ($window(@pop)) { .timer.pop off | window -c @pop }
  .timer.pop 1 6 window -c @pop

  window -pd +d @pop $mouse.x $calc($mouse.y + %br.sz) %w 20
  drawrect -f @pop 1 2 0 0 %w 20
  drawtext -r @pop 16777215 Arial 12 4 2 %r
  ; free mem in 60
  if (!$timer(.close).com) .timer.close 1 60 fclose crayola
}
alias fgetname {
  var %sz = %br.sz, %fitall = 0
  var %m = $calc($int($calc(%br.w / %sz)) - %fitall)
  if ($mouse.x > $calc(%sz * %m)) return off edge
  var %x = $calc($int($calc($mouse.x / %sz)) + 1)
  var %y = $int($calc($mouse.y / %sz))
  var %i = $calc(%m * %y + %x)
  if (%i > $lines(%br.file)) return no more colors
  .fseek -l crayola %i
  var %r = $fread(crayola)
  if (*declare*;* iswm %r) {
    if ($1) clipboard %r
    ; $gettok(%r,2,32)
    return $gettok(%r,2,32)
  }
  else return not a color
}
alias mouseover2 {
  if (!$fopen(crayola)) .fopen crayola %br.file
  var %r = $fgetname(0)
  var %w = $calc(8 * $len(%r))
  tokenize 32 $thumbend
  drawrect -f @board 1 2 $1 $2 300 %br.sz
  drawtext -r @board 16777215 Arial 12 $1 $2 %r
  ; free mem in 60
  if (!$timer(.close).com) .timer.close 1 60 fclose crayola
}
alias thumbend {
  var %n = $lines(%br.file)
  var %fitall = 0
  var %m = $calc($int($calc(%br.w / %br.sz)) - %fitall)
  var %y = $calc($int($calc(%n / %m)) * %br.sz)
  var %x = $calc((%n % %m) * %br.sz)
  return %x %y
}

alias initcolopal {
  var %z = 320, %sat = 0.6, %light = 0.3
  var %i = 0, %rgb, %j = 0
  write -c colopal.txt
  while (%j < 3) {  
    ; hsv 0 is a color // reversed 1.0 - 0 = 1 // hsv 1 is a color, 0 = black
    %i = 0 
    while (%i < %z) {
      %rgb = $hsv2rgb($calc(1.0 - (%i / %z)), %sat, %light)
      inc %i
      if ($calc(((%i / %z) * 10) % 2) == 0) e $int($calc((%i / %z) * 100)) %
      write colopal.txt #declare $+(hsv_,%sat,_,%i) = rgb < $replace(%rgb,$chr(32),$chr(44)) >;
    }
    inc %j
    inc %sat 0.2
    inc %light 0.3
  }
  %j = 0
  %sat = 0.6
  %light = 0.5
  while (%j < 3) {
    ; hsl 0 = black //rev 1.0 - 0 = 1 // hsl 0 is a color, 1 = black
    %i = 1
    while (%i <= %z) {
      %rgb = $hsl2rgb($calc(1.0 - (%i / %z)), %sat, %light)
      ; WRITE
      write colopal.txt #declare $+(hsl_,%sat,_,%i) = rgb < $replace(%rgb,$chr(32),$chr(44)) >;
      inc %i
      ; PROGESS
      if ($calc(((%i / %z) * 10) % 2) == 0) e $int($calc((%i / %z) * 100)) %
    }
    inc %j
    inc %sat 0.2
    inc %light 0.2
  } 

}
; for(float i = 0; i < 1; i+=0.01) HSL2RGB(rgb, i, 0.5, 0.5);
alias hsl2rgb {
  ; (h,s,l) in the range of 0-1
  var %v, %r = 0, %g = 0, %b = 0, %h = $1, %s = $2, %l = $3
  var %vsf, %mid1, %mid2, %m, %sv

  if (%l <= 0.5)   %v = $calc(%l * (1.0 + %s))
  else %v = $calc(%l + %s - (%l * %s))
  if (%v > 0) {
    %m = $calc(%l + %l - %v)
    %sv = $calc((%v - %m ) / %v)
    %h = $calc(%h * 6.0)
    %vsf = $calc(%v * %sv * (%h - $int(%h)))
    %mid1 = $calc(%m + %vsf)
    %mid2 = $calc(%v - %vsf)
    ; switch (sextant)
    %h = $int(%h)
    if (%h == 0) { %r = %v | %g = %mid1 | %b = %m }
    if (%h == 1) { %r = %mid2 | %g = %v | %b = %m }
    if (%h == 2) { %r = %m | %g = %v | %b = %mid1 }
    if (%h == 3) { %r = %m | %g = %mid2 | %b = %v }
    if (%h == 4) { %r = %mid1 | %g = %m | %b = %v }
    if (%h == 5) { %r = %v | %g = %m | %b = %mid2 }
  }
  ;  e %r %g %b
  return %r %g %b
}

alias h2rgb {
  var %h = $calc(($1 * 360) % 360), %r, %g, %b
  if (%h < 0) %h = $calc(%h + 360)

  if (%h <= 120) {
    %r = $calc((120 - %h) / 60)
    %g = $calc(%h / 60)
    %b = 0
  }
  else if (%h <= 240) {
    %r = 0
    %g = $calc((240 - %h) / 60)
    %b = $calc((%h - 120) / 60)
    ; e %r %g %b
  }
  else if (%h <= 360) {
    %r = $calc((%h - 240) / 60)
    %g = 0
    %b = $calc((360 - %h) / 60)
  }
  return $min(%r,1) $min(%g,1) $min(%b,1)
}

alias hsv2rgb {
  var %h = $1, %s = $2, %v = $3
  var %sat = $h2rgb(%h)
  return $multv($addv($multv(%sat, %s), $&
    $multv(1 1 1, $calc(1 - %s))), %v)
}
alias min {
  if ($1 < $2) return $1
  if ($2 < $1) return $2
  return $1
}
menu @board {
  ; sclick: clipname
  sclick: mouseover
  ; mouse: mouseover dont suppose it can open and close windows that fast
  mouse: mouseover2
  mIRC: actvmirc
  HSV Color Pallet: { initcolopal | crayola }
  DLL
  .Load DLL: loadll
  .unLoad DLL: unloadll
  .isloaded: dll irc.dll unloadchk@24
}
alias loadll {
  dll $lib loadll@24
}
alias unloadll {
  dll $lib unloadll@24
}
menu status {
  HSV Color Pallet: { initcolopal | crayola }
}
on 1:LOAD: load -rs macro.mrc
